import * as z from 'zod';
import { Prisma } from '../../../generated/prisma';
import Decimal from 'decimal.js';
import { PaymentStatusSchema } from '../enums/PaymentStatus.schema';
import { ClaimCreateNestedOneWithoutPaymentInputObjectSchema as ClaimCreateNestedOneWithoutPaymentInputObjectSchema } from './ClaimCreateNestedOneWithoutPaymentInput.schema';
import { PatientCreateNestedOneWithoutPaymentInputObjectSchema as PatientCreateNestedOneWithoutPaymentInputObjectSchema } from './PatientCreateNestedOneWithoutPaymentInput.schema';
import { UserCreateNestedOneWithoutUpdatedPaymentsInputObjectSchema as UserCreateNestedOneWithoutUpdatedPaymentsInputObjectSchema } from './UserCreateNestedOneWithoutUpdatedPaymentsInput.schema';
import { NpiProviderCreateNestedOneWithoutPaymentsInputObjectSchema as NpiProviderCreateNestedOneWithoutPaymentsInputObjectSchema } from './NpiProviderCreateNestedOneWithoutPaymentsInput.schema';
import { ServiceLineTransactionCreateNestedManyWithoutPaymentInputObjectSchema as ServiceLineTransactionCreateNestedManyWithoutPaymentInputObjectSchema } from './ServiceLineTransactionCreateNestedManyWithoutPaymentInput.schema';
import { ServiceLineCreateNestedManyWithoutPaymentInputObjectSchema as ServiceLineCreateNestedManyWithoutPaymentInputObjectSchema } from './ServiceLineCreateNestedManyWithoutPaymentInput.schema';
import { CommissionBatchItemCreateNestedManyWithoutPaymentInputObjectSchema as CommissionBatchItemCreateNestedManyWithoutPaymentInputObjectSchema } from './CommissionBatchItemCreateNestedManyWithoutPaymentInput.schema'

import { DecimalJSLikeSchema, isValidDecimalInput } from '../../helpers/decimal-helpers';
const makeSchema = () => z.object({
  userId: z.number().int(),
  totalBilled: z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Prisma.Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'totalBilled' must be a Decimal",
}),
  totalPaid: z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Prisma.Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'totalPaid' must be a Decimal",
}).optional(),
  totalAdjusted: z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Prisma.Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'totalAdjusted' must be a Decimal",
}).optional(),
  totalDue: z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Prisma.Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'totalDue' must be a Decimal",
}),
  mhPaidAmount: z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Prisma.Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'mhPaidAmount' must be a Decimal",
}).optional().nullable(),
  copayment: z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Prisma.Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'copayment' must be a Decimal",
}).optional(),
  adjustment: z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Prisma.Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'adjustment' must be a Decimal",
}).optional(),
  status: PaymentStatusSchema.optional(),
  notes: z.string().optional().nullable(),
  icn: z.string().optional().nullable(),
  createdAt: z.coerce.date().optional(),
  claim: z.lazy(() => ClaimCreateNestedOneWithoutPaymentInputObjectSchema).optional(),
  patient: z.lazy(() => PatientCreateNestedOneWithoutPaymentInputObjectSchema),
  updatedBy: z.lazy(() => UserCreateNestedOneWithoutUpdatedPaymentsInputObjectSchema).optional(),
  npiProvider: z.lazy(() => NpiProviderCreateNestedOneWithoutPaymentsInputObjectSchema).optional(),
  serviceLineTransactions: z.lazy(() => ServiceLineTransactionCreateNestedManyWithoutPaymentInputObjectSchema).optional(),
  serviceLines: z.lazy(() => ServiceLineCreateNestedManyWithoutPaymentInputObjectSchema).optional(),
  commissionBatchItems: z.lazy(() => CommissionBatchItemCreateNestedManyWithoutPaymentInputObjectSchema).optional()
}).strict();
export const PaymentCreateInputObjectSchema: z.ZodType<Prisma.PaymentCreateInput> = makeSchema() as unknown as z.ZodType<Prisma.PaymentCreateInput>;
export const PaymentCreateInputObjectZodSchema = makeSchema();
